﻿@echo off

SET true=1==1
SET false=1==0

SET root_dir=%~dp0
SET drive=%CD:~0,3%
SET downloadedFilesDir=%root_dir%
SET destinationFilesDir=%root_dir%..\

SET log_file=%drive%copy_updater.log

ECHO root_dir is: %root_dir%
ECHO drive is: %drive%
ECHO downloadedFilesDir is: %downloadedFilesDir%
ECHO destinationFilesDir is: %destinationFilesDir%
ECHO log_file is: %log_file%

CALL :gettimestamp timestamp
ECHO start auto update iiko process %timestamp% >> %log_file%

FOR /L %%A IN (1,1,12) DO (
 ECHO interation: %%A  >> %log_file%
 CALL :checkiikorunning
 CALL :timeout 5
)
EXIT /B %ERRORLEVEL% 

:gettimestamp
 SET %~1=%date%_%time%
EXIT /B 0

:checkiikorunning
 TASKLIST /fi "imagename eq Resto.Front.Api.Host.exe" /fi "status eq RUNNING" /fo csv /nh | FIND /I "Resto.Front.Api.Host.exe"
 if "%errorlevel%"=="0" (
  ECHO iiko is runned...  >> %log_file%
 ) ELSE (
  ECHO iiko is stopped, start update logic...  >> %log_file%
  CALL :makeUpdate
  ECHO end process  >> %log_file%
  EXIT
 )
EXIT /B 0

:timeout
 SET /A delay=%~1+1
 PING 127.0.0.1 -n %delay% > nul
EXIT /B 0

:makeUpdate
 echo end check iiko process %time% >> %log_file%
 echo copy_new_files.bat> %drive%excluded.txt
 echo install.bat>> %drive%excluded.txt
 echo start copy process %time% >> %log_file%
 xcopy /y /f /s "%downloadedFilesDir%"*.* "%destinationFilesDir%" /EXCLUDE:%drive%excluded.txt >> %log_file%
 if %errorlevel% neq 0 exit /b %errorlevel%
 echo end copy process %time% >> %log_file%
 echo copied success >> %log_file%
 del %drive%excluded.txt
EXIT /B 0
